



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Nginx】Nginx在Linux下的入门介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Nginx】Nginx在Linux下的入门介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 13:52:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Nginx的安装</h2>
<h3>下载、解压</h3>
<p>从<a href="http://nginx.org/" rel="external nofollow noreferrer">Nginx</a>下载安装包，我下的是<code>nginx-1.8.0.tar.gz</code>。解压后的目录为：</p>
<pre class="prettyprint linenums"><code>[root@blog third_package]# tar -zxf nginx-1.8.0.tar.gz<br />
[root@blog third_package]# ll nginx-1.8.0<br />
total 652<br />
drwxr-xr-x 6 1001 1001   4096 Jul 23 18:17 auto<br />
-rw-r--r-- 1 1001 1001 249124 Apr 21  2015 CHANGES<br />
-rw-r--r-- 1 1001 1001 379021 Apr 21  2015 CHANGES.ru<br />
drwxr-xr-x 2 1001 1001   4096 Jul 23 18:17 conf<br />
-rwxr-xr-x 1 1001 1001   2478 Apr 21  2015 configure<br />
drwxr-xr-x 4 1001 1001   4096 Jul 23 18:17 contrib<br />
drwxr-xr-x 2 1001 1001   4096 Jul 23 18:17 html<br />
-rw-r--r-- 1 1001 1001   1397 Apr 21  2015 LICENSE<br />
drwxr-xr-x 2 1001 1001   4096 Jul 23 18:17 man<br />
-rw-r--r-- 1 1001 1001     49 Apr 21  2015 README<br />
drwxr-xr-x 8 1001 1001   4096 Jul 23 18:17 src<br />
</code></pre>
<h3>依赖的软件</h3>
<p>安装之前把依赖的软件装上，我这里用<code>YUM</code>：<code>yum -y install gcc gcc-c++ pcre pcre-devel zlib zlib-devel openssl openssl-devel</code></p>
<h3>安装</h3>
<pre class="prettyprint linenums"><code>[root@blog nginx-1.8.0]# pwd<br />
/installation_package/nginx-1.8.0<br />
[root@blog nginx-1.8.0]#<br />
[root@blog nginx-1.8.0]# ./configure --prefix=/opt/nginx_1<br />
</code></pre>
<p>执行<code>./configure</code>后在添加了一个目录<code>objs</code>，<code>--prefix</code>表示安装到此目录，如果不设置默认安装到<code>/usr/local/nginx</code>。</p>
<p>编译工作：</p>
<pre class="prettyprint linenums"><code>make<br />
make install<br />
</code></pre>
<h3>启动</h3>
<p>用<code>/opt/nginx_1/sbin/nginx</code>启动，默认使用的是安装目录的<code>NGINX_HOME/conf/nginx.conf</code>，也就是<code>/opt/nginx_1/conf/nginx.conf</code>。<br /><br />
当然，也可以使用<code>/opt/nginx_1/sbin/nginx -c /opt/nginx_1/conf/nginx.conf</code>指定配置文件。</p>
<h2>Nginx的反向代理</h2>
<p>我们常用Nginx做反向代理，在设置反向代理前，应先了解下<code>正向代理</code>和<code>反向代理</code>。</p>
<h3>如何设置</h3>
<p>将到达Nginx的请求转到后端具体的主机，可通过设置<code>上游服务器</code>和<code>代理转发</code>。比如：</p>
<pre class="prettyprint linenums"><code>http {<br />
    ...<br />
    upstream myweb {<br />
        server 127.0.0.1:9999;<br />
    }

    server {<br />
        ...<br />
        location /myweb {<br />
            proxy_pass  http://myweb;<br />
        }<br />
    }

}<br />
</code></pre>
<p>设置好之后，将上游服务器<code>127.0.0.1:9999</code>也部署好，就可以通过Nginx享受上游服务器的具体服务了。</p>
<p>但要注意请求的信息的转发，比如后端是一台TOMCAT，里面运行一个Servet打印各项参数：</p>
<pre class="prettyprint linenums"><code>    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {<br />
        StringBuffer sb = new StringBuffer();<br />
        sb.append(&quot;request.getProtocol() : &quot; + request.getProtocol()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getScheme() : &quot; + request.getScheme()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRemoteAddr() : &quot; + request.getRemoteAddr()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRemoteHost() : &quot; + request.getRemoteHost()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getServerPort() : &quot; + request.getServerPort()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRemotePort() : &quot; + request.getRemotePort()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getQueryString() : &quot; + request.getQueryString()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRemoteUser() : &quot; + request.getRemoteUser()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getMethod() : &quot; + request.getMethod()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getLocalAddr() : &quot; + request.getLocalAddr()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getLocalName() : &quot; + request.getLocalName()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getPathInfo() : &quot; + request.getPathInfo()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRequestURI() : &quot; + request.getRequestURI()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getRequestURL() : &quot; + request.getRequestURL()).append(&quot;\n&quot;);<br />
        sb.append(&quot;request.getContextPath() : &quot; + request.getContextPath()).append(&quot;\n&quot;);

        response.getWriter().append(&quot;Served at: &quot;).append(request.getContextPath()).append(&quot;\n&quot;).append(sb);<br />
    }<br />
</code></pre>
<p>直接访问TOMCAT，<code>http://nick-huang.com:9999/myweb/PrintEnvInfoServlet?keyword=hello-world</code>，打印的信息是这样的：</p>
<pre class="prettyprint linenums"><code>Served at: /myweb<br />
request.getProtocol() : HTTP/1.1<br />
request.getScheme() : http<br />
request.getRemoteAddr() : 客户端IP<br />
request.getRemoteHost() : 客户端IP<br />
request.getServerPort() : 9999<br />
request.getRemotePort() : 64494<br />
request.getQueryString() : keyword=hello-world<br />
request.getRemoteUser() : null<br />
request.getMethod() : GET<br />
request.getLocalAddr() : 服务端IP<br />
request.getLocalName() : 服务端IP<br />
request.getPathInfo() : null<br />
request.getRequestURI() : /myweb/PrintEnvInfoServlet<br />
request.getRequestURL() : http://nick-huang.com:9999/myweb/PrintEnvInfoServlet<br />
request.getContextPath() : /myweb<br />
</code></pre>
<p>只作反向代理的设置，访问NGINX，<code>https://nick-huang.com:777/myweb/PrintEnvInfoServlet?keyword=hello-world</code>，后打印：</p>
<pre class="prettyprint linenums"><code>Served at: /myweb<br />
request.getProtocol() : HTTP/1.0<br />
request.getScheme() : http<br />
request.getRemoteAddr() : 127.0.0.1<br />
request.getRemoteHost() : 127.0.0.1<br />
request.getServerPort() : 80<br />
request.getRemotePort() : 54856<br />
request.getQueryString() : keyword=hello-world<br />
request.getRemoteUser() : null<br />
request.getMethod() : GET<br />
request.getLocalAddr() : 127.0.0.1<br />
request.getLocalName() : localhost<br />
request.getPathInfo() : null<br />
request.getRequestURI() : /myweb/PrintEnvInfoServlet<br />
request.getRequestURL() : http://myweb/myweb/PrintEnvInfoServlet<br />
request.getContextPath() : /myweb<br />
</code></pre>
<h3>反向代理后的请求头信息传递</h3>
<p>可以发现，反向代理后<code>Protocol</code>、<code>RemoteAddr</code>、<code>ServerPort</code>、<code>RequestURL</code>等参数均有所不同，那么我们需要设置代理时传递参数。<br /><br />
Nginx配置：</p>
<pre class="prettyprint linenums"><code>    upstream myweb {<br />
        server 127.0.0.1:9999;<br />
        keepalive 32;<br />
    }<br />
    ...<br />
        location /myweb {<br />
            proxy_set_header Host $host:$server_port;<br />
            proxy_set_header X-Real-IP $remote_addr;<br />
            proxy_set_header REMOTE-HOST $remote_addr;<br />
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;<br />
            proxy_set_header X-Forwarded-Proto $scheme;<br />
            proxy_http_version 1.1;<br />
            proxy_set_header Connection &quot;&quot;;<br />
            proxy_pass  http://myweb;<br />
        }

</code></pre>
<p>相关说明，请点击链接：<a href="http://nginx.org/en/docs/http/ngx_http_proxy_module.html#proxy_http_version" rel="external nofollow noreferrer">proxy_http_version</a>、<a href="http://nginx.org/en/docs/http/ngx_http_upstream_module.html#keepalive" rel="external nofollow noreferrer">keepalive</a>。</p>
<p>Tomcat的<code>/conf/server.xml</code>的<code>Host</code>节点下添加：</p>
<pre class="prettyprint linenums"><code>&lt;Valve className=&quot;org.apache.catalina.valves.RemoteIpValve&quot; remoteIpHeader=&quot;X-Forwarded-For&quot; protocolHeader=&quot;X-Forwarded-Proto&quot; protocolHeaderHttpsValue=&quot;https&quot; httpsServerPort=&quot;777&quot; /&gt;<br />
</code></pre>
<p>相关说明，请点击链接：<a href="http://tomcat.apache.org/tomcat-6.0-doc/api/org/apache/catalina/valves/RemoteIpValve.html" rel="external nofollow noreferrer">org.apache.catalina.valves Class RemoteIpValve</a></p>
<p>访问<code>https://nick-huang.com:777/myweb/PrintEnvInfoServlet?keyword=hello-world</code>，日志是这样的：</p>
<pre class="prettyprint linenums"><code>Served at: /myweb<br />
request.getProtocol() : HTTP/1.1<br />
request.getScheme() : https<br />
request.getRemoteAddr() : 客户端IP<br />
request.getRemoteHost() : 客户端IP<br />
request.getServerPort() : 777<br />
request.getRemotePort() : 55022<br />
request.getQueryString() : keyword=hello-world<br />
request.getRemoteUser() : null<br />
request.getMethod() : GET<br />
request.getLocalAddr() : 127.0.0.1<br />
request.getLocalName() : localhost<br />
request.getPathInfo() : null<br />
request.getRequestURI() : /myweb/PrintEnvInfoServlet<br />
request.getRequestURL() : https://nick-huang.com:777/myweb/PrintEnvInfoServlet<br />
request.getContextPath() : /myweb<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2jwkx8.html">Network</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q25gxoq.html">WaitType：ASYNC&lowbar;NETWORK&lowbar;IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jpxpw9.html">ios基础篇（三十）&mdash;&mdash; AFNetworking的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxz5re8.html">Java魔法堂：枚举类型详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5mg38.html">App上架出现问题-ERROR ITMS-90034</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde5g4j9.html">C&plus;&plus; 数组参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn1gm6q.html">&lbrack;汇编学习笔记&rsqb;&lbrack;第十三章int指令&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1mvpx9.html">UVA 10603 Fill</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ydjyn8.html">c&num;之从服务器下载压缩包，并解压</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyodrm9.html">微信和支付宝支付模式详解及实现（&period;Net标准库）- OSS开源系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kngm59.html">深度揭秘腾讯云TSF日调用量超万亿次背后技术架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz74yg8.html">iOS设计指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjggkk8.html">【Keras篇】---利用keras改写VGG16经典模型在手写数字识别体中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw55ed8.html">DNS搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5jv3dq.html">jQuery的介绍和选择器详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/902710jq.html">设计模式学习---UML常见关系的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjw317q.html">在C语言中除法运算为什么没有小数部分？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjz3ep8.html">LinkedHashMap源码剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koedpjq.html">BZOJ - 1009 KMP&plus;可达矩阵</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o46615q.html">R语言列表list函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e4jymk9.html">linux 学习笔记五  查看文件篇章</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvyvdj8.html">gcc 各种参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rprlo9.html">使用C&num;的is、as操作符来转型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r514mdq.html">STM32&mdash;&mdash;C语言课堂原代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j12ey49.html">解决 插件LArea 在IOS上浮出软键盘问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw3kw48.html">&lbrack;ZJOI2012&rsqb;波浪</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjv5669.html">linux查看服务安装目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r510v4q.html">Java 泛型 介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oggme8.html">js获取浏览器屏幕的尺寸</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51657q.html">【模拟】&lbrack;NOIP2014&rsqb;螺旋矩阵&lbrack;c&plus;&plus;&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
